<?php
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: DebugExpress
// Copyright (C) 2003 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://xexpress.sourceforge.net/
// Original Author of file: Brave Cobra
// Purpose of file:
// Contains the Debug Object object to provide debug info on classes
//
// ----------------------------------------------------------------------
class DebugExpress
{
  var $DebugOutput;
  var $debugArray;
  var $options = array(
        "spacer"                => "&nbsp;&nbsp;&nbsp;",
        "lf"                    => "<br>",
        "structOpen"            => "<b>",
        "structClose"           => "</b>",
        "specialOpen"           => "<i>",
        "specialClose"          => "</i>",
        //"useErrorHandler"       => false,
        //"echoResult"            => false,
        //"returnResult"          => false,
        "convertHtml"           => true,
        "convertSpecial"        => true,
        "dumpObjectFunctions"   => true,
        "dumpObjectVars"        => true,
        "dumpObjectInheritance" => true
    );
  var $depth = 0;
  var $start;
  var $stop;
    function DebugExpress()
    {

     return true;
    }

   function initDebug()
   {
     $initial = pnSessionGetVar('cedebug');
     if (!$initial) {
       //pnSessionSetVar('cedebug', '<table border=1>');
       $debugArray = array();
       pnSessionSetVar('CEDebugging', serialize($debugArray));
     }
     return true;
   }

   function getDebugOutput()
   {
     if (pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
     $bugarray = $this->prepareOutput();
     $D .= "
       <SCRIPT>
         cedebugw=window.open('',\"DEBUGVAR\",\"WIDTH=700,HEIGHT=500,scrollbars=yes,resizable=yes,toolbar=yes,menubar=no\");
         if (cedebugw) {
           cedebugw.focus();
           cedebugw.document.writeln(\"$bugarray\"+'<b>Called : '+window.location.href+'</b></table><hr>');
         }
       </SCRIPT>";
       pnSessionDelVar('CEDebugging');
       return $D;
     }
   }

   function prepareOutput()
   {
     if (pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
       $new = pnSessionGetVar('CEDebugging');
       $new = unserialize($new);
       $newoutput = "<TABLE SIZE=100% CELLSPACING=0 CELLPADDING=0 BORDER=0><TR><TD><HR SIZE=1></TD></tr><tr><TD WIDTH=1%><FONT FACE='Verdana,arial' SIZE=1>".date("d.m.Y")."&nbsp;".date("H:i:s")."</FONT></TD></TR></TABLE><TABLE width=100% border=1><TH>Variable</TH><TH>Value</TH>";
       if ($new){
       foreach ($new as $name=>$var)
       {
         $value = explode('^',$var);
         $value[1] = ereg_replace('/n','',$value[1]);
         $newoutput .= "<tr><td>".pnVarPrepForDisplay($value[0])."</td><td>$value[1]</td></tr>";
       }
       $newoutput .= "</table>";
       return $newoutput;
       }else{
       return '';
       }
     }
   }
   function dump ($var,$value,$listoutput=true) {
      $res = $this->_getValue($value);
      if ($listoutput){
        $new = pnSessionGetVar('CEDebugging');
        $new = unserialize($new);
        $new[] = ($var.'^'.$res);
        $new = serialize($new);
        pnSessionSetVar('CEDebugging', $new);
        return true;
      }
      else
      {
        return $res;
      }
   }

   //internal function
   function _getValue($value)
   {
      if (is_object($value)) {
        $res = $this->_dumpObject($value);
      }
      elseif (is_array($value)) {
        $res = $this->_dumpArray($value);
      }
      elseif (is_int($value)) {
        $res = $this->_dumpInteger($value);
      }
      elseif (is_float($value)) {
        $res = $this->_dumpFloat($value);
      }
      elseif (is_double($value)) {
        $res = $this->_dumpDouble($value);
      }
      elseif (is_long($value)) {
        $res = $this->_dumpLong($value);
      }
      elseif (is_string($value)) {
        $res = $this->_dumpString($value);
      }
      elseif (is_bool($value)) {
        $res = $this->_dumpBoolean($value);
      }
      elseif (is_resource($value)) {
        $res = $this->_dumpResource($value);
      }
      elseif (is_null($value)) {
        $res = $this->_dumpNull($value);
      }
      else {
        $res = $this->_dumpUnknown($values);
      }
      return $res;
   }

   function _dumpObject ($object) {
     $this->depth++;
     $str = $this->options['structOpen'] . 'object(' . get_class($object) . ')';

        $separator = ' extends ';
        $parent = $object;
        do {
            $temp = get_parent_class($parent);
            $str .= ($temp == '' ? '' : $separator) . $temp;
            $parent = $temp;
        } while ($parent != '');
        $str .= ' {'.$this->options['structClose'].$this->options['lf'];

        $vars = get_class_vars(get_class($object));
        //sort the varnames alphabetically
        ksort($vars);
        reset($vars);
        // dump all vars

        foreach ($vars as $name => $itsvalue) {
            $str .= str_repeat($this->options['spacer'], $this->depth);
            $str .= $name.' => ';
            $str .= $this->_getValue($itsvalue) . $this->options['lf'];
        }
        $str .= $this->options['lf'];

    // dump all methods

        $methods = get_class_methods(get_class($object));
        sort($methods);
        reset($methods);
        foreach ($methods as $name => $value) {
            $str .= str_repeat($this->options['spacer'], $this->depth);
            $str .= 'function ' . $value. '()'. $this->options['lf'];
        }
        $str .= str_repeat($this->options['spacer'], $this->depth - 1);

    $this->depth--;
    return $str . $this->options['structOpen'] . '}' . $this->options['structClose'];
   }

   //internal function
   function _dumpInteger ($thing) {
    return 'int(' . $thing . ')';
   }

   //internal function
   function _dumpFloat ($thing) {
    return 'float(' . $thing . ')';
   }

   //internal function
   function _dumpDouble ($thing) {
    return 'double(' . $thing . ')';
   }

   //internal function
   function _dumpLong ($thing) {
    return 'long(' . $thing . ')';
   }

   //internal function
   function _dumpBoolean ($thing) {
    return 'bool('. ($thing == false ? 'false' : 'true') .')';
   }

   //internal function
   function _dumpResource($thing) {
    get_resource_type($thing) . "(" . $thing . ")";
   }

   //internal function
   function _dumpNull ($thing) {
    return 'null';
   }

   //internal function
   function _dumpUnknown ($thing) {
    return 'Unknown('.$thing.')';
   }

   //internal function
   function _dumpString ($str) {
      $res = "string[".strlen($str)."]('";
      if ($this->options['convertHtml'] == true) {
        $str = htmlentities($str);
      }
    // replaces the special chars
      $search = array ("/\n/", "/\t/", "/\f/","/\r/");
      $replace = array ($this->options['specialOpen'] . "/n" . $this->options['specialClose'],  $this->options['specialOpen'] . "/t" . $this->options['specialClose'],  $this->options['specialOpen'] . "/f" . $this->options['specialClose'],$this->options['specialOpen'] . "/r" . $this->options['specialClose']);
      $str = preg_replace($search, $replace, $str);
      $str = ereg_replace(";","\;",$str);
      $res .= $str . "')";
      return $res;
   }

   //internal function to display an array
   function _dumpArray ($array) {
    $this->depth++;
    $str = $this->options['structOpen']. 'array[' . sizeof($array) . '] {' . $this->options['structClose'] . $this->options['lf'];
    while(list($var, $val) = each($array)) {
        $str .= str_repeat($this->options['spacer'], $this->depth);
        $str .= $var . ' => ';
        $str .= $this->_getValue($val);
        $str .= $this->options['lf'];
    }
    $str .= str_repeat($this->options['spacer'], $this->depth - 1);
    $this->depth--;
    return $str . $this->options['structOpen'] . '}' . $this->options['structClose'];
  }

   //internal function to calculate the time
   function _calculateTime($time, $id) {
      $current = $time[1] - $this->start[$id][1];
      $current += $time[0] - $this->start[$id][0];
      return $current;
   }

   //function to start timer
   function startTimer ($id = 'default')
   {
     $this->start[$id] = explode(' ', microtime());
     unset($this->stop[$id]);
   }

   //function to stop a timer
   function stopTimer ($id = 'default') {
     $this->stop[$id] = explode(' ', microtime());
     return $this->_calculateTime($this->stop[$id], $id);
   }

   //function to get the current status of a timer
   function getTime ($id = 'default') {
     $time = explode(' ', microtime());
     if (!isset($this->start[$id])) {
        return 0;
     }
     if (isset($this->stop[$id])) {
        $time = $this->stop[$id];
     }
     $new = unserialize(pnSessionGetVar('CEDebugging'));
     $newtime = $this->_calculateTime($time, $id);
     $var = "Timer $id";
     $new[] = ($var.'^'.$newtime.' sec.');
     $new = serialize($new);
     pnSessionSetVar('CEDebugging', $new);
     return true;
   }
}
?>
