DROP TABLE IF EXISTS testroom_paged_helptexts;
CREATE TABLE testroom_paged_helptexts (
    constant varchar(255),
    language varchar(50) DEFAULT 'all' NOT NULL,
    title varchar(255),
    text mediumtext,
    image varchar(255)
);

INSERT INTO testroom_paged_helptexts VALUES ('_configuremodule','eng','Module settings','Most global settings are found here on the Module Settings panel. It is important that you familiarize yourself with the selectors and what they do. A number of PagEd problems can be traced to incorrect settiings in this panel.

Please see the help on each section for more detail.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedmodulelayout','eng','Module layout and navigation','Background color/Panel font color:
These are settings affecting the PagEd workspace only. They do not in any way affect content, articles and menus. But you can set a module background color/tect color for the PagEd editor panels in order to make the module looks in tune with your site layout and colors.

Show icons:
At the top right of Module Settings, you will see a blue square icon indicating which part of PagEd you are in. Page editing, menu editing etc have their own icons, and thses icons are intended to make module navigation easier. You may deactivate them by unchecking this box.

Show help:
Self-explanatory - select \"No help display\" if you are so familiar with PagEd that you do not need popup help texts.

Control panel links:
Upon first PagEd install you will see a top and bottom double-line of links to other parts of PagEd. This selector determines where or whether you wnat such links.
Note: The control panel links connect with the PagEd Permissions system (PagEd Control Panel/Permissions). Non-admins will only see the links they have access to.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedcontentediting','eng','Content editing','Pagination:
Once you start creating PagEd articles, they will appear in the Page Manager. If you are productive, the article listing may grow long and impractical. Setting a pagination number will split up the listing into smaller, manageable pieces. 25 means that turning to Page Manager will display the first 25 articles, and you will see links above and below leading to the next 25 and so on.

Warning prompt before deleting:
Check here if you want PagEd to ask you if you are \"really sure\" when you delete a page/pages.

Show hex color codes:
The PagEd color selector lets you select among the 216 socalled \"web safe\" colors - colors you know will display correctly in every browser/monitor. However this safe setting is less necessary now then before since most browsers and monitors support millions of colors. 
Checking for \"Show hex color codes\" will let you manually enter any color code you want - for instance the hex codes specified in most theme.php files and style sheets.
Hex codes can be read from Photoshop. For more info on them, do a web search.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedcontentdisplay','eng','Content display','Image library:
One of the most important settings in the module. PagEd uses image resizing in many situations. This means you can decide how big your images should be when displayed in content, no matter how large they are when you upload them. This makes content display tidyer and reduces page load time. 
To resize images, a server-side image handling library is required. PagEd supports 2: GD and Netpbm. GD comes as a standard part of most PHP installations, so most likely your provider offers you this. There is however a downside with GD - it does not support the GIF format. Therefore, installing and selecting NetPBM may be a better option. Download NetPBM from the PagEd web site, and upload the unzipped pack as \"netpbm\" into your PagEd folder. CHMOD folder and files inside to 755.
If your server is running PHP in Safe Mode, GD is your only option. Installing and selecting NetPBM will only give you broken images.

NetBPM path: If you are running the image module Gallery, you may already have NetPBM installed. PagEd will search for this in some locations. If you know that it is installed, and PagEd didn`t find it, enter the path yourself.

Date format: Select the type of date format most fitting to your site. This setting will be used by page display - \"Updated (date)\".

Sort news: The PagEd news display can show your news items either sorted by how old they are, or you can chose to move them up and down yourself. If you select \"User ordered\", up/down arrows will be displayed in News Manager.

Number of items: Select how many items to display in news.

Alltopics template: When you create the standard PagEd topics menu block in Postnuke admin/Blocks, the first link will be to the \"Main topic page\", showing a short description of all topics. The layout of this page will use the template you select here. Templates are created in the Template Manager.

Front page: PagEd can be your front page module. Select a page from the list of pages you have created. 

Content block page: A setting which doesn`t really apply anymore, since PagEd now comes with an unlimited number of content blocks, which are configured when you create them in Postnuke admin/Blocks.','');
INSERT INTO testroom_paged_helptexts VALUES ('_miscellaneous','eng','Miscellaneous','Date stamp: Check this box if you want to display \"Updated (date)\" below your article. Note: You can select a few date format display options in Module Settings.

Show reads: PagEd keeps count of how many times a certain article has been accessed. Check this box if you want this information displayed below your article.	

Show author? A check here will display the article author below the article.
		
Print icon at top of page/Print icon at bottom of page: Select one or both of these to display icons above/below your article linking to a display of the same article without the surrounding Postnuke site (header, blocks etc).

Let users comment: You may let readers comment on PagEd content. The sitewide third-party module EZComments must be installed, and once this is done, you must turn to your Postnuke admin/Modules and select \"Edit\" at PagEd, then check for \"Enable EZComments for this module\". PagEd will know that EZComments is present and prompt you for \"Let users comment\".','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedbackupmanager','eng','Backup Manager','Frequent backup of data is advised on a web site. The PagEd Backup Manager is an extra service meant for those of you who are not familiar with an SQL admin like for instance phpMyAdmin, or those of you who want a sipler and faster way of backing up just your Postnuke installation.
Selectable options are
- The PagEd tables only. As these may be the tables containing the most and frequently updated content, they may be the most important backup choice.
- The whole PN database. Advisable to do perhaps monthly, or if you are making changes to your installation, like upgrading PN or installing new modules.
- The PagEd help table in your language. This is most relevant if you have created a translation of the English help set and want to submit it to the PagEd team.

Once a backup is created, it will be displayed in the Backup Manager, and you may download it to your PC.
In future PagEd versions, there will be options to mail the backup, or to transfer it via FTP to another server.','');
INSERT INTO testroom_paged_helptexts VALUES ('_topicmanager','eng','Topic manager','You may use PagEd as much as you like without even using topics. However, if your number of pages grows large, it is practical to sort them in topics.

With pages sorted under topics, you can create topic overview pages or blocks, which will show all pages under a topic, shortlisted, with some text and an image. Topics are also governed by
- Postnuke read permissions: You may assign no read access to a certain topic for a certain group, for instance if you want to hide it from unregistered users. Use the following form in Postnuke admin/Permissions:
User group - PagEd:: - Topic:X: - Access level
where X is the topic ID.

Once you have created a topic, it will be displayed here in the topic manager, and you may edit or delete it. When you create an article, your list of topics will be selectable for you to place the page under.

The PagEd topics are not connected to the Postnuke topics.','');
INSERT INTO testroom_paged_helptexts VALUES ('_newsmanager','eng','News manager','This list reflects the news display on your front page. To make an article appear as news, check the \"Show as news\" box when you create the page, or click \"Show as news\" in Page Manager.
From the News Manager you can remove items from news, or edit them, or time program them, if you want them to be displayed for a certain amount of time.
NOTE: News in PagEd normally displays in a block, which you mst create in Postnuke admin/Blocks.

The News Manager will show your news items sorted by time or by manual order, depending on which setting you have selected in Module settings. Manual order means you will be able to move items up or down with link arrow icons.','');
INSERT INTO testroom_paged_helptexts VALUES ('_templatemanager','eng','Template manager','PagEd comes with a variety of layout templates, meant for different needs. When you install PagEd, there are 3:
- Global Page Layout. This template cannot be deleted, but you can edit it. The global layout is always selectable when you create a new page. Editing the global layout to suit your need will let you create new pages faster than if you should set colors and fonts for every new page.
- News Layout. This template is used by the PagEd news display.
- Global Menu Layout. Works like the global page layout. You may design every menu differently, but you can also select the global layout when creating a menu.

Apart from the standard templates, there are 2 kinds of user-created templates. 
1. Overview templates are used by topic overview display - a page where all pages under a topic is displayed with their title/first image/first text section.
2. Full page templates are used by article display.

You can build as many as you want, and you may also delete them. Overview templates are selectable when you create topics. Full page templates are selectable when you create articles.','');
INSERT INTO testroom_paged_helptexts VALUES ('_groupmanager','eng','Group manager','The Group Manager is not a place for creating or deleting groups. This you must do in Postnuke admin. Groups created in Postnuke admin is what you see in PagEd`s Group Manager. 
The Group Manager serves one purpose: To give groups editor access to parts of PagEd. NOTE: Before doing any modifications here, you must give the group in question Edit access to PagEd in Postnuke Permissions. This is an extra security measure and the first \"door\" into PagEd editing.

To see what the group permissions options are in Group Manager, click on a group to access the configuration panel. More help will be displayed there.','');
INSERT INTO testroom_paged_helptexts VALUES ('_selectnewlayoutheader','eng','Configure layout for your new page, or use global layout and continue','This panel is your first step towards creating an article in PagEd. Now, to make the first time easy for yourself, you may select the global layout template and continue straight to adding content:
- Select the number of sections you want
- Select a topic to place your article in (To create a topic, turn to Topic Manager)
- Select the global template from the Template dropdown
- Press \"Use, procede to add content\".

If you do not want to use the global layout, scroll down and read help for the panel subsections.','');
INSERT INTO testroom_paged_helptexts VALUES ('_outerlayout','eng','Background and element placement','Theme override: You may select a different Postnuke theme to use when this article is displayed. If no theme is selected here, the site default theme will be used.

Backgroundcolor: Use the color selector to define the background color of your page, or select \"use theme background color\" if you want the page to be transparent. Note: The color selector gives you a choice of 216 web-safe colors. But if you check the \"Show hex color codes\" box in Module Settings, every PagEd color selector will display a text box where you may enter any hex color code you like.

Layout: A mostly self-explanatory dropdown list of different ways of placing images and text on a page

Right blocks: With this box checked, your page wil occupy the center field of your site, but with your right blocks shown also.

Section links: An article with many subtitles/subsections may be easier to navigate if you check for \"Section links\". Above the first section, a list of every subtitle will display, each subtitle actings as an in-page link to the correct text section.','');
INSERT INTO testroom_paged_helptexts VALUES ('_writing','eng','Writing','Self-explanatory. PagEd does not let you select font families at the moment, but if you want a certain font set, open the PagEd/functionssmall.php file and edit the topmost lines.','');
INSERT INTO testroom_paged_helptexts VALUES ('_images','eng','Images','Mostly self-explanatory. A couple of notes:
Maximum image width: 
This really applies to the longest side of an image. Thus an image 300 pixels wide and 500 pixels high will be resized so that the height is reduced to the max size setting.

Link to original size image is:
If your max image size setting is smaller than an image, the image will be resized for display. However you may have the riginal size image displayed in a popup box. How this box is accessible is what you set here - either no access, access via clicking on the image itself, or via a \"See original size\" text link below.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pointers','eng','Links','Links parsed by PagEd can have a different color/size than the text itself, and you may also specify a link icon graphic.

PagEd comes with several link parse options. Enter an URL or a mail adress in your text, and PagEd will concert it automatically to a working link. You can also link to other pages by writing PAGEDX in your text, X being the page ID taken from Page Manager. The same goes for topics: Write TOPICX.','');
INSERT INTO testroom_paged_helptexts VALUES ('_createpagecontentheader','eng','Add content to your new page','News: 
A check here will make your page show up in the News Manager AND news display. It is advised that you do not check this box until you are satisfied with content and layout (use preview), to keep your page invisible until it is complete.

Page author: 
PagEd stamps your page with your Postnuke login name, and this name is used for editor permission functionality. As the login name does not always look good with \"Written by...\" below your page, you may enter another name here, which will then be the author name displayed for readers.

Language: 
Select \"all\" to make the article viewable by all, or select a specific language if you want the article to be accessible only by those logged in on a certain language.

Title: 
The title of your article. 

Note:
This field is ONLY for identification purposes in PagEd`s Page Manager. The contents of this field are not displayed for readers. But if your Page Manager lists 5 pages called \"Travel Report\", you may add a note here to separate them in the manager.

Ingress: 
Ingress is a sort of \"head text section\". Text entered here will be displayed in bold, and you can use it for an \"article teaser\" or a summary of what the rest of your page is about. The ingress field is not mandatory.

Subtitle: Subsection title.
Text: An entire text section may be entered here. You may use plain text, or html. Postnuke`s built-in WYSIWYG editor can be used.
Note that PagEd can parse several string types into links automatically:
URL- parsed as link
Mail adress - parsed as mailto link
PAGEDX - parsed as link to other PagEd article, X being the page ID in Page Manager
TOPICX -  parsed as link to PagEd topic, X being the topic ID in Topic Manager
Filename.suffix - Enter the name of a media file present in your media folder (see Module Settings). If the file is present, PagEd will create a link to it. Example: Myclients.pdf.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedarchivedorlinkedimage','eng','Images','PagEd comes with several image options in content:
1. Image upload. Click Browse and navigate to an image on your local machine. Note that only gif, jpg and png are supported. Note also that PagEd many servers require image names without blank spaces or foreign characters.
2. Browse PagEd`s image archive. Uploaded images are placed in PagEd`s pictures folder, which you may browse by using the \"Browse PagEd\" button. Note: If you select an image with the dropdown list, you must click the \"Show\" button before clicking \"Select and return\".
3. Browse Photoshare. This photo album module works together with PagEd. Install it, and PagEd will detect it automatically and give you an extra browse button to access the Phiotoshare image archive.
4. Linked. The lower image address field may also be used to enter a server-local or external image address.

Please see the Module Settings panel for some detail on setting up image handling in PagEd.

Image text: For a small text below the image - a description, a copyright notice, a byline etc.','');
INSERT INTO testroom_paged_helptexts VALUES ('_edcontent','eng','Content','Top story: Topic overview pages display the first section ov every page under that topic. You may however chose to display one article in full above the rest - a kind of \"top story\".

Show topic title: In general news display, pages from a number of different topics may be shown. This selector can have each page`s topic displayed above the page title. The same goes for display of a full article. If you chose to show the topic title, it will act as a lnik to the topic in question.

Sort news: Chose to sort pages in topic overview according to updated-time or by title. (User-ordered does not mean you can move them up and down like in news - this is a function not yet coded for topics.)

Number of items: The same meaning as \"News count\" in Module Settings. Select how many topic articles you want displayed in a topic overview.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedselecttemplates','eng','Select templates for...','Placing pages in topics means you can easily define a layout template for every page the topic contains. 
Overview: Select a template to be used by the overview page for this topic.
Custom overview layout: Together with the setting above, you may chose a more \"spiced up\" topic overview page. If this box is checked, only some attributes of the overview template will be used. 

Single pages: Select a template to be used by all pages in your topic. Selecting a template here will lock all pages to the template. If you want more flexibility, do not select a template, and select for each page individually when you create them - the same templates will be available.
 
Create block: PagEd can create a block automatically for you showing the overview of your topic. The block will be shown on the Postnuke/Administration/Blocks/New block list and must be created and placed there.
A topic block is practical if you want to show block overview on your site front page, or if you want to display more topic overviews than one on the same page.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagemanager','eng','Page manager','The main starting page for handling created content in PagEd. All articles created will show up here, and you may sort them either according to title, page ID, note (archive identifier) or time stamp. You may also select to show only pages under a certain topic.

When your page list grows long, you may chose to split it up into chunks of 25 or 30 or 50 or whatever is practical. This is done by selcecting the desired \"pagination\" number in Module Settings.

From Page Manager you may procede to edit content or layout in a page. You can set a page as news, or delete it.
The \"set as news\" and \"delete\" functions can be applied to multiple pages by using the checkboxes and pressing the desired button below the list.

The Page Manager is permission-governed. Non-admins will only see pages they have edit access to.','');
INSERT INTO testroom_paged_helptexts VALUES ('_settimeheader','eng','Set news timing for','Programming a news article means setting a starting date and an ending date for it. Before the starting date, the article will not show up in news display. After the ending date, it will be removed.
PagEd will do some checking of the dates you enter to avoid logical errors.','');
INSERT INTO testroom_paged_helptexts VALUES ('_configuregroupaccess','eng','Configure group access','The Permissions panel governs what kind of access a certain group will have to create and edit pages, templates and menus. Most fields should be self-explanatory.
Note: Apart from configuring access here, you must give the group edit access to PagEd as a module in Postnuke admin/Permissions:
Group name - PagEd:: - :: - Access level

A common request is how to let a group create and edit content, and nothing else, leaving to the admin to look through content and publish it. To set this up, give the group the following permissions:

Module settings: No access
All editor panels: Custom access

Pages: Access to own pages
News: No access (means the group will not see a link to the News Manager, and they will not be able to define a page as news)
Menus: No access  (means the group will not see a link to the Menu Manager - thus they will not be able to place their page on a working menu)
Templates: No access (to create or edit templates)
Topics: Custom access (Below this, your created topics will each get an access level dropdown - thus you can let your group write pages only under certain topics, which will be the ones they can select when creating content, and viewing pages in Page Manager)','');
INSERT INTO testroom_paged_helptexts VALUES ('_menumanager','eng','Menu manager','The menu builder may perhaps seem to be the most complex part of PagEd at first. It plays together with the Postnuke block system and also the Postnuke permission system. You may create and edit PagEd menus as much as you like before making your menus appear to your visitors, since they will not show until you have actually created them in Postnuke also.

PagEd comes with 10 empty menus. When you first open the Menu Manager, they are all empty. Start by picking any one of the 10 and select \"Start using\". This will bring you to the layout settings where you can follow the help further.

Once a menu is created, you will get options in Menu Manager to 
- Edit Layout of your menu
- Edit the menu items
- Recycle the menu, meaning all items will be deleted, and you can use it again to build a new menu

After setting layout and adding items to your menu, note the ID number fo your menu and turn to Postnuke admin/Blocks. Click \"Create new block\" and chose the PagEd menu with the correct number. Place it and select a language also if you like.

PagEd menus follow Postnuke permissions for display. To hide a PagEd menu from a certain user group, use the following setup:
User group - PagEd:: - Menu title:: - Access level.','');
INSERT INTO testroom_paged_helptexts VALUES ('_editmenulayoutheader','eng','Edit menu layout','See the \"Create menu layout\" panel for help on this.','');
INSERT INTO testroom_paged_helptexts VALUES ('_toplevelitems','eng','Top level items','You may select some options for the top level items of a menu, as well as sub level items. Color, font size and bullet graphic should be self-explanatory. The \"Tabulator\" setting lets you move items in from the left side of the menu block. Normally you would set the top level item tabulator to 0, and the sub level item tabulator to 10 or 20 pixels, for instance.','');
INSERT INTO testroom_paged_helptexts VALUES ('_secondlevelitems','eng','Sub items','Once your layout has been configured, you may procede to add items. Click the \"Items\" button.','');
INSERT INTO testroom_paged_helptexts VALUES ('_selectnewmenulayoutheader','eng','Configure layout for your new menu, or use global layout and continue','The simple way of proceding from layout editing to adding menu items is simply to click on \"Use the global layout\" button. The global menu layout is, by the way, editable from Template Manager.

If you want an individually configured layout for your menu, there are a few options which are explained in each section. The first is perhaps the most important: The drop-down selector for sub item display. This is where you chose to have your menu appear as
- static (all items are shown all the time)
- collapsible (top level items show as default, sub level items appear when you click on the top level items)
- Vertical or horizontal popups (top level items show as default, sub level items appear on mouseover)

Note that in the current version, you can only have one popup menu displayed at the same time. The same goes for the collapsible. It is an issue we are working on.

Note also that the \"horizontal popup\" option is one of very few ways to actually have a horizontal menu in Postnuke. Try it out, but only in a center block.','');
INSERT INTO testroom_paged_helptexts VALUES ('_addmenucontentheader','eng','Menu Builder: Add items','This is the basic menu builder, where you add items to your menu. Confusing at first, playing around with it should give you the idea in a short time. Remember, nobody will actually see the menu you are building until you activate it in Postnuke admin/Blocks!

To add an item, enter the link text at the top left. 
Then enter either an URL in the box to the right (local or external) or select a PagEd article from the drop-down list - if you have already created articles. 
Select also if you want your link to open in the same browser window, or a new one. Finally, add \"hover\" text - that is, text which will appear when a reader moves the mouse over the link text.

When the content of your link is done, place the item by selecting the radio button in the left square. When starting to build a menu, there will be only one radio, which is the one you select. Press \"Add and reload\" to add your item.

The new menu item will show up to the left, with three radio buttons. They are meant for the next item you create. 
* To place the next item above the first one, select the radio to the left of the first item.
* To place the next item below the first one, select the radio to the lower left of the first item.
* To place the next item as a sub-item to the first, select the radio to the right of the first item.

Created menu items will also appear in the right field, where your menu is previewed as it will actually look.

To edit a menu item, click on it in the left field.

Below the 2 menu fields, there are some extra navigational options. 
* The left drop-down will let you continue to edit another menu. 
* The links to the right are
- Show ID on page list: Make the page ID appear in addition to the page title in the PagEd article dropdown.
- Go to Move mode: Leave the \"Add item\" panel and enter a panel where you can move menu items around.
- Go to Delete mode: Leave the \"Add item\" panel and enter a panel wher you can delete items from your menu.','');
INSERT INTO testroom_paged_helptexts VALUES ('_movemenucontentheader','eng','Menu Builder: Move items','This panel gives you three menu display fields. The right one shows your menu as it will appear. 
The left fields represent the \"from\" and the \"to\" in moving menu items. To move a menu item, click the radio button nect to it in the left menu field. Then select the radio representing where you want to move the item, in the center field. The radio button placement here functions just like the \"Add item\" panel radio buttons. When the \"from\" and the \"to\" are selcted, press \"move and reload\" below the center menu.

Note: By moving a top level item, you will move all suib level items below it too.
Note II: You can move items from menu to another. Select the \"from\" menu and the \"to\" menu from the drop-down selectors below the menus.','');
INSERT INTO testroom_paged_helptexts VALUES ('_deletemenucontentheader','eng','Menu Builder: Delete items','This panel should be self-explanatory. Just check the boxes next to the items you want to delete. Note that deleting a top level item will also delete sub items under it.
Note II: Deleting links to PagEd articles does not delete the articles!','');
INSERT INTO testroom_paged_helptexts VALUES ('_editmenuitemheader','eng','Edit menu item','Enter modified information for your item here. CPress \"Select and return\" to get back to the menu builder.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pageimportlayout','eng','Import pages','Import from EZCMS:
PagEd grew out of some code modifications to EZCMS. If you have been using this module for site content, you can import the content into PagEd here. Existing PagEd articles are not influenced by this. But \"old\" EZCMS articles will all get new ID numbers during the import process.

Import from Postnuke News:
You may import content from Postnuke`s news module into PagEd. The Postnuke content will not be altered or removed, but you will be able to handle it in PagEd.
If desired, you may chose to import Postnuke topics also. If you plan on importing, it could be a good idea to do it early, to get a hang of how PagEd handles existing content, and also to make use of already existing topics, if you import them.

You may chose to place imported content directly into an existing PagEd topic.','');
INSERT INTO testroom_paged_helptexts VALUES ('_areyousuretodel','eng','Are you sure you want to delete?','When delting a page/pages, this screen appears if you have selected \"Show warning prompt before deleting?\" in PagEd Module Settings.

When deleting a topic, you will be prompted to move pages under this topic to another topic. 

When deleting a template, you will be prompted to set a new template for
- Pages using this template, if any.
- Topics using this template, if any.','');
INSERT INTO testroom_paged_helptexts VALUES ('_editpagecontentheader','eng','Edit content','Most options on this panel are explained in the \"Create content\" help text. When editing existing content, some new options are available to you.
- Update time: This is your option to backdate an article. If you do not touch this setting, the original time stamp set at first creation stays. Below the date selectors, you may check the \"update time\" checkbox, which will set the current date as the article`s \"updated\" time stamp.
- Author overrride: As PagEd admin, you can edit articles written by others. If you check this box, the author stamp on the article is changed from the original authors login name to your own. You may still leave the original author`s name signature on the article. Remember, article edit permission are determined by the login name stamp, not the displayed author name.
- Insert/move/delete sections: During page editing, you may at any time modify the number of text sections, or move them up or down. At the very bottom of the page editor, there is also a dropdown sections selector. Use this if you want to add several extra sections below the existing ones.','');
INSERT INTO testroom_paged_helptexts VALUES ('_editpagelayoutheader','eng','Edit layout for','This panel is identical to the one shown when you create an article, exept for the fact that instead of the \"Select how many sections you want\" option, you must now select how many EXTRA sections you want. Note: This is also configurable from the Edit Content panel.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedcreateoverviewtemplate','eng','Create new overview template','Most of this panel is explained in the help text for \"Create page layout\". There are some differences:
- This is a template creator, separate from page creation. You must therefore specify a name for your template, to identify it on the \"Select template\" dropdowns shown when you create a topic. Specify a short description also, if you like.
- \"Top links\": As an overview template is used for topic overviews only, you may check this box to have the titles of the pages shown in short in a topic overview as links above the items. The top links will link to each short-displayed page.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedcreatepagetemplate','eng','Create new full page template','Most of this panel is explained in the \"Create page layout\" help text. Since this is a template creator, you must however specify a name (and a decsirption if you want) for your template, to identify it in the \"Select template\" drop-downs shown in topic and page editors.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagededitoverviewtemplate','eng','Edit overview template','See the \"Create overview template\" panel for help on this.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagededitpagetemplate','eng','Edit full page template','See the \"Create full page template\" help text for information on this panel.','');
INSERT INTO testroom_paged_helptexts VALUES ('_areyousuretodelmenu','eng','Are you sure you want to empty','If you chose to empty a menu, all items are removed. You must then also deactivate or delete the menu in Postnuke admin/Blocks, if this is a menu you have been displayng on your site.
Note: Emptying a menu does not affect PagEd articles linked to by the menu.','');
INSERT INTO testroom_paged_helptexts VALUES ('_pagedmediafiles','eng','Media files','MP3 folder path: 
Apart from displaying images, PagEd supports a growing number of media file types. A media folder to store them in does not come with the module pack, so you must create it yourself with your FTP client. You may place it anywhere you like on your server, then specify the path here.

Upload media file: 
Most file types can be uploaded into the selected media folder. Just be aware of possible browser timeout problems if the file you want to upload is large, and your connection is slow.
Some providers also limit the size of uploadable files. 10MB is common.','');


