<?php
// $Id: common.php,v 1.42 2004/06/08 18:28:07 jornlind Exp $
// =======================================================================
// Pagesetter by Jorn Lind-Nielsen (C) 2003.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

  // These three are unused now, but must be saved in order to be able to upgrade correctly
define('pagesetterApprovalPreview',  0);
define('pagesetterApprovalApproved', 1);
define('pagesetterApprovalRejected', 2);

define('pagesetterFieldTypeString', 0);
define('pagesetterFieldTypeText',   1);
define('pagesetterFieldTypeHTML',   2);
define('pagesetterFieldTypeBool',   3);
define('pagesetterFieldTypeInt',    4);
define('pagesetterFieldTypeReal',   5);
define('pagesetterFieldTypeDate',   6);
define('pagesetterFieldTypeTime',   7);
define('pagesetterFieldTypeImage',  8);

define('pagesetterFieldTypeListoffset', 100);

define('pagesetterEditRowsPerPage', 20);

define('pagesetterAccessNone',      ACCESS_NONE);
define('pagesetterAccessAuthor',    ACCESS_EDIT);
define('pagesetterAccessEditor',    ACCESS_ADD);
define('pagesetterAccessModerator', ACCESS_DELETE);

  // Workflow operation results
define('pagesetterWFOperationError',   0);
define('pagesetterWFOperationWarning', 1);
define('pagesetterWFOperationOk',      2);

// =======================================================================
// Error handling
// =======================================================================

function pagesetterErrorPage($file, $line, $msg)
{
  if ($file == null  ||  !pnSecAuthAction(0, 'pagesetter::', ".*", ACCESS_ADMIN))
    $text = $msg;
  else
    $text = "$file($line): $msg";

  pnSessionSetVar('errormsg', $text);
  return $text;
}


function pagesetterErrorAPI($file, $line, $msg, $setSession=true)
{
  global $pagesetterErrorMessageAPI;

  if ($file == null  ||  !pnSecAuthAction(0, 'pagesetter::', ".*", ACCESS_ADMIN))
    $pagesetterErrorMessageAPI = $msg;
  else
    $pagesetterErrorMessageAPI = "$file($line): $msg";

  if ($setSession)
    pnSessionSetVar('errormsg', $pagesetterErrorMessageAPI);

  return false;
}


function pagesetterErrorAPIGet()
{
  global $pagesetterErrorMessageAPI;

  return $pagesetterErrorMessageAPI;
}


function pagesetterWarningWorkflow($msg)
{
  global $pagesetterWarningMessageWorkflow;

  $pagesetterWarningMessageWorkflow = $msg;

  return pagesetterWFOperationWarning;
}


function pagesetterWarningWorkflowGet()
{
  global $pagesetterWarningMessageWorkflow;

  return $pagesetterWarningMessageWorkflow;
}


function pagesetterXMLErrorUnexpected($name, $state)
{
  return "Unexpected $name tag in $state state";
}

// =======================================================================
// Date handling
// =======================================================================

function pagesetterFormatSQLDate($date)
{
  return (empty($date) ? "NULL" : "'" . pnVarPrepForStore($date) . "'");
}


// =======================================================================
// Publication dynamic table handling
// =======================================================================
function pagesetterGetPubTableName($tid)
{
  return pnConfigGetVar('prefix') . '_pagesetter_pubdata' . $tid;
}


function pagesetterGetPubColumnName($ftid)
{
  if (!isset($ftid))
    return 'pg_id';

  return 'pg_field' . $ftid;
}


function pagesetterGetPublicationUniqueID($tid, $pid = '', $lang = null, $page = null)
{
  return $tid . '_' . $pid . (isset($lang) ? "|$lang" : '') . (isset($page) ? "|$page" : '');
}


function pagesetterGetPubTypeName($tid)
{
  if (!pnModAPILoad('pagesetter', 'admin'))
    return pagesetterErrorApi(__FILE__, __LINE__, 'Failed to load Pagesetter admin API');

  $pubTypeInfo =  pnModAPIFunc( 'pagesetter',
                                'admin',
                                'getPubTypeInfo',
                                array('tid' => $tid) );

  return $pubTypeInfo['publication']['title'];
}


function pagesetterSmartyGetTemplateFilename(&$smarty, $tid, $template)
{
  $pubName = pagesetterGetPubTypeName($tid);
  $filename = "$pubName-$template.html";

  if (!$smarty->template_exists($filename))
    $filename = "Default-$template.html";

  if (!$smarty->template_exists($filename))
    $filename = "Default.html";

  return $filename;
}


function pagesetterSmartyGetTemplates($tid)
{
  $pubName = pagesetterGetPubTypeName($tid);

  return array( array('name' => 'list',
                      'file' => "$pubName-list.html"),
                array('name' => 'list-header',
                      'file' => "$pubName-list-header.html"),
                array('name' => 'list-footer',
                      'file' => "$pubName-list-footer.html"),
                array('name' => 'full',
                      'file' => "$pubName-full.html"),
                array('name' => 'print',
                      'file' => "$pubName-print.html"),
                array('name' => 'block-list',
                      'file' => "$pubName-block-list.html") );
}


function pagesetterSmartyClearTypeCache($tid)
{
  $templates = pagesetterSmartyGetTemplates($tid);

  $smarty = new pnRender();

  foreach ($templates as $template)
    $smarty->clear_cache($template['file']);
}


function pagesetterSmartyClearCache($tid, $pid)
{
  $cacheID = pagesetterGetPublicationUniqueID($tid, $pid);

  $smarty = new pnRender();
  $smarty->clear_cache(null,$cacheID);
}


// =======================================================================
// Field handling
// =======================================================================

  // A simplified coerce function for converting URL values
  // to values usable for guppy edit. Probably not complete,
  // but at least it works for dropdowns.
function pagesetterCoerceFieldValue($type, $val)
{
  if ($type >= pagesetterFieldTypeListoffset)
    return intval($val);

  return $val;
}


function pagesetterFieldTypesGet($type)
{
    // Is this a user defined field type?
  if ($type >= pagesetterFieldTypeListoffset)
  {
      // Get list ID
    $lid = $type - pagesetterFieldTypeListoffset;

    if (!pnModAPILoad('pagesetter', 'admin'))
      return pagesetterErrorApi(__FILE__, __LINE__, 'Failed to load Pagesetter admin API');

    $list = pnModAPIFunc( 'pagesetter',
                          'admin',
                          'getList',
                          array('lid'           => $lid, 
                                'forSelectList' => true) );

    return array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'select',
      'options'    => $list['items'],
      'layoutKind' => 'input',
      'sqlType'    => 'INT'
    );
  }

  static $fieldTypes = array
  (
      // string
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'string',
      'layoutKind' => 'input',
      'width'      => '400',
      'sqlType'    => 'VARCHAR(255)'
    ),
      // text
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'string',
      'layoutKind' => 'input',
      'view'       => 'text',
      'width'      => '600',
      'height'     => '100',
      'sqlType'    => 'MEDIUMTEXT' 
    ),
      // html
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'string',
      'layoutKind' => 'input',
      'view'       => 'html',
      'width'      => '600',
      'height'     => '300',
      'sqlType'    => 'MEDIUMTEXT'
    ),
      // bool
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'bool',
      'layoutKind' => 'input',
      'width'      => '100',
      'sqlType'    => 'TINYINT'
    ),
      // int
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'int',
      'layoutKind' => 'input',
      'width'      => '100',
      'sqlType'    => 'INT'
    ),
      // real
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'real',
      'layoutKind' => 'input',
      'width'      => '100',
      'sqlType'    => 'FLOAT'
    ),
      // date
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'date',
      'layoutKind' => 'input',
      'width'      => '100',
      'sqlType'    => 'DATE'
    ),
      // time
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'time',
      'layoutKind' => 'input',
      'width'      => '100',
      'sqlType'    => 'TIME'
    ),
      // image
    array
    (
      'fieldKind'  => 'input',
      'fieldType'  => 'image',
      'layoutKind' => 'input',
      'width'      => '200',
      'sqlType'    => 'VARCHAR(255)'
    ),
  );

  return $fieldTypes[$type];
}


function pagesetterFieldTypesGetOptionList()
{
  static $options = array
  (
    array( 'title' => _PGTYPESTRING, 'value' => 0 ),
    array( 'title' => _PGTYPETEXT,   'value' => 1 ),
    array( 'title' => _PGTYPEHTML,   'value' => 2 ),
    array( 'title' => _PGTYPEBOOL,   'value' => 3 ),
    array( 'title' => _PGTYPEINT,    'value' => 4 ),
    array( 'title' => _PGTYPEREAL,   'value' => 5 ),
    array( 'title' => _PGTYPEDATE,   'value' => 6 ),
    array( 'title' => _PGTYPETIME,   'value' => 7 ),
    array( 'title' => _PGTYPEIMAGE,  'value' => 8 )
  );

  if (!pnModAPILoad('pagesetter', 'admin'))
    return pagesetterErrorApi(__FILE__, __LINE__, 'Failed to load Pagesetter admin API');

  $lists = pnModAPIFunc( 'pagesetter',
                         'admin',
                         'getLists' );

  $dynamicOptions = array();
  foreach ($lists as $list)
    $dynamicOptions[] = array( 'title' => $list['title'], 'value' => pagesetterFieldTypeListoffset+$list['id'] );

  return array_merge($options,$dynamicOptions);
}


// =======================================================================
// PostNuke interface specialities
// =======================================================================

  // Get array of topics ready to use in Guppy
function pagesetterPNGetTopics()
{
  list($dbconn) = pnDBGetConn();
  $pntable = pnDBGetTables();

  $topicsTable  = $pntable['topics'];
  $topicsColumn = $pntable['topics_column'];

  $sql = "SELECT   $topicsColumn[tid],
                   $topicsColumn[topicname]
          FROM     $topicsTable
          ORDER BY $topicsColumn[topicname]";

  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"PNGetTopics" failed: ' . $dbconn->errorMsg() . " while executing: $sql");

  $topics = array();

  $topics[] = array('value'     => -1,
                    'title'     => _PGNONE);

  for (; !$result->EOF; $result->MoveNext())
  {
    $topics[] = array('value' => intval($result->fields[0]),
                      'title' => $result->fields[1]);
  }

  $result->Close();

  return $topics;
}


function pagesetterPNGetLanguages()
{
  modules_get_language();

  $languages = languagelist();
  $langList = array( array( 'value' => 'x_all',
                            'title' => _ALL) );
  
  foreach ($languages as $langName => $langTitle)
    if ($langName != 'x_all')
      $langList[] = array('value' => $langName,
                          'title' => $langTitle);

  return $langList;
}


// =======================================================================
// Misc.
// =======================================================================

  // Replace all "$xyz" references in filter with the appropriate
  // URL variable's value.
function pagesetterReplaceFilterVariable($filterStr)
{
  $matches = array();
  if (preg_match_all("/[$]([a-zA-Z_]+)/", $filterStr, $matches))
  {
    foreach ($matches[1] as $match)
    {
      $varName = $match;
      $value = pnVarCleanFromInput($varName);
      $filterStr = str_replace("\$$varName", $value, $filterStr);
    }
  }
  return $filterStr;
}


  // Fetch array of all filters on URL
function pagesetterGetFilters(&$baseURLArgs)
{
  $i = 1;
  $filter = array();

    // Get unnumbered filter string
  $filterStr = pnVarCleanFromInput('filter');
  if (isset($filterStr))
  {
    $filter[] = pagesetterReplaceFilterVariable($filterStr);
    $baseURLArgs['filter'] = $filterStr;
  }

    // Get filter1 ... filterN
  while (true)
    {
    $filterURLName = "filter$i";
    $filterStr     = pnVarCleanFromInput($filterURLName);

    if (empty($filterStr))
      break;

    $filter[] = pagesetterReplaceFilterVariable($filterStr);
    $baseURLArgs[$filterURLName] = $filterStr;

    ++$i;
  }

  return $filter;
}


function pagesetterFlattenPubData(&$pubCore)
{
  $tmp = array();
  foreach ($pubCore as $key => $value)
  {
    $tmp["core_$key"] = $pubCore[$key];
    unset($pubCore[$key]);
  }

  $pubCore += $tmp;
}


function pagesetterUnflattenPubData(&$pubData)
{
  $core = array();
  foreach ($pubData as $key => $value)
  {
    if (substr($key,0,5) == 'core_')
    {
      $core[substr($key,5)] = $pubData[$key];
      unset($pubData[$key]);
    }
  }

  $pubData['core'] = $core;
}


function pagesetterSplitPages($text)
{
  return preg_split('/<hr[ \r\n\t]+class=\"pagebreak\"[ \r\n\t]*\/[ \r\n\t]*>/', $text);
}


// =======================================================================
// Database locking and pid/revision# generation
// =======================================================================

function pagesetterLockTables(&$dbconn, $tables)
{
  $sql = null;
  foreach ($tables as $table)
    if ($sql == null)
      $sql = "LOCK TABLES $table WRITE";
    else
      $sql .= ", $table WRITE";

  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"pagesetterLockTables" failed: ' 
                                                  . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


function pagesetterUnlockTables(&$dbconn)
{
  $sql = "UNLOCK TABLES";
  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"pagesetterUnlockTables" failed: ' 
                                                  . $dbconn->errorMsg() . " while executing: $sql");

  return true;
}


function pagesetterGetNextCount(&$dbconn, &$pntable, $countName)
{
  $countersTable = $pntable['pagesetter_counters'];
  $countersColumn = $pntable['pagesetter_counters_column'];

    // Lock counter table to avoid concurrence problems
  pagesetterLockTables($dbconn, array($countersTable));

    // Get current count

  $sql = "SELECT $countersColumn[count] FROM $countersTable WHERE $countersColumn[name] = '" . pnVarPrepForStore($countName) . "'";
  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"pagesetterGetNextCount" failed: ' 
                                                  . $dbconn->errorMsg() . " while executing: $sql");

  if ($result->EOF)
    $count = 0;
  else
    $count = intval($result->fields[0]) + 1;

  $result->Close();

    // Update count

  $sql = "REPLACE INTO $countersTable ($countersColumn[count], $countersColumn[name])
          VALUES ($count, '" . pnVarPrepForStore($countName) . "')";
  $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"pagesetterGetNextCount" failed: ' 
                                                  . $dbconn->errorMsg() . " while executing: $sql");

  pagesetterUnlockTables($dbconn);

  return $count;
}


function pagesetterGetNextRevision(&$dbconn, &$pubTable, &$pubColumn, $pid)
{
    // Locking of table to avoid concurrency problems must be done by caller

  $sql = "SELECT MAX($pubColumn[revision]) FROM $pubTable WHERE $pubColumn[pid] = $pid";

  $result = $dbconn->execute($sql);

  if ($dbconn->errorNo() != 0)
    return pagesetterErrorApi(__FILE__, __LINE__, '"pagesetterGetNextRevision" failed: ' 
                                                  . $dbconn->errorMsg() . " while executing: $sql");
  if ($result->EOF)
    $revision = 1;
  else
    $revision = intval($result->fields[0]) + 1;

  $result->Close();

  return $revision;
}


function pagesetterApprovalState2String($stateName, &$workflow)
{
  $state = $workflow->getState($stateName);
  if ($state === false)
    return false;

  return $state->getTitle();
}


function pagesetterGetTID($tid = null)
{
  if (!isset($tid))
    $tid = pnVarCleanFromInput('tid');

  if (!isset($tid))
    $tid = pnModGetVar('pagesetter','frontpagePubType');

  if (!isset($tid))
    return false;

  return $tid;
}


function pagesetterGetCurrentPermission($tid, $pid)
{
  if (pnSecAuthAction(0, 'pagesetter::', "$tid:$pid:", pagesetterAccessModerator))
    return pagesetterAccessModerator;
  
  if (pnSecAuthAction(0, 'pagesetter::', "$tid:$pid:", pagesetterAccessEditor))
    return pagesetterAccessEditor;

  if (pnSecAuthAction(0, 'pagesetter::', "$tid:$pid:", pagesetterAccessAuthor))
    return pagesetterAccessAuthor;

  return pagesetterAccessNone;
}


// =======================================================================
// Searching
// =======================================================================

class PagesetterSearchCallback
{
  function start() {}

  function found($tid, $pid, $pubTitle, $title, $url) {}

  function stop() {}
};


// =======================================================================
// Array merge
// =======================================================================
function is_hash( $var ) {
 if( is_array( $var ) ) {
   if (count($var) == 0)
     return true;
   $keys = array_keys( $var );
   for( $i=0; $i<count($keys); $i++ ) 
     if( is_string($keys[$i] ) ) return true;
 }
 return false;
}

function array_join_merge( $arr1, $arr2 ) {
 //print_r($arr1); echo "IsHash: ".is_hash($arr1)."\n";
 //print_r($arr2); echo "IsHash: ".is_hash($arr2)."\n";
 if( is_array( $arr1 ) and is_array( $arr2 ) ) {
   // the same -> merge
   $new_array = array();
   if( is_hash( $arr1 ) && is_hash( $arr2 ) ) {
     // hashes -> merge based on keys
     $keys = array_merge( array_keys( $arr1 ), array_keys( $arr2 ) );
     foreach( $keys as $key ) {
       //echo "$key: " . array_key_exists($key,$arr1) . array_key_exists($key,$arr2) . "\n";
       if (!array_key_exists($key,$arr1))
         $new_array[$key] = $arr2[$key];
       else if (!array_key_exists($key,$arr2))
         $new_array[$key] = $arr1[$key];
       else
         $new_array[$key] = array_join_merge( $arr1[$key], $arr2[$key] );
     }
   } else {
     // two real arrays -> merge
     $size = max(count($arr1),count($arr2));
     for ($i=0; $i<$size; ++$i) {
       //echo "$i: ";
       $new_array[$i] = array_join_merge($arr1[$i], $arr2[$i]);
     }
   }
   
   //print("RESULT: \n"); print_r($new_array);
   return $new_array;
 } else {
   // not the same ... take new one if defined, else the old one stays
   return $arr2;
   //return $arr2 ? $arr2 : $arr1;
 }
}


  // Thanks to webmaster at ragnarokonline dot de - found on www.php.net
if (!function_exists("file_get_contents")) {
  function file_get_contents($filename, $use_include_path = 0) {
   $data = ""; // just to be safe. Dunno, if this is really needed
   $file = @fopen($filename, "rb", $use_include_path);
   if ($file) {
     while (!feof($file)) $data .= fread($file, 1024);
     fclose($file);
   }
   return $data;
  }
}

?>
