<?php
// $Id: guppy_postnuke.php,v 1.11 2004/06/14 20:52:41 jornlind Exp $
// =======================================================================
// Guppy/PostNuke integration by Jorn Lind-Nielsen (C) 2003.
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WithOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

define('guppyPostNukeModule', 'pagesetter');



function guppy_postnuke()
{
  global $guppyBaseURL;
  global $guppyThemeURL;

    // Get base URL for htmlArea additions that need to know where we are when running fullscreen editor mode
  $postnukeBaseURL = ($_SERVER["HTTPS"] == "on" ? "https" : "http")
                     . "://" . $_SERVER["HTTP_HOST"] . strrev(strstr(strrev($_SERVER["PHP_SELF"]),"/"));
  
  $guppyBaseURL  = "$postnukeBaseURL/modules/" . guppyPostNukeModule . "/guppy";
  $guppyThemeURL = "$guppyBaseURL/themes/" . pnVarPrepForOS(pnUserGetTheme());
  $guppyThemeDir = "modules/pagesetter/guppy/themes/" . pnVarPrepForOS(pnUserGetTheme());
  $themeBaseURL  = "$postnukeBaseURL/themes/" . pnVarPrepForOS(pnUserGetTheme());

  $photoshareThumbnailSize = pnModGetVar('photoshare', 'thumbnailsize');

  if (!@is_dir($guppyThemeDir))
    $guppyThemeURL = "modules/" . guppyPostNukeModule . "/guppy/themes/guppy";

    // Ensure guppy stylesheet is included

  $cssURL = $guppyThemeURL . "/style.css";

    // Use PostNuke variable for insertion of special HTML header tags.
  global $additional_header;
  if (!is_array($additional_header))
    $additional_header = array();
  $additional_header[] = "<link rel=\"StyleSheet\" href=\"$cssURL\" type=\"text/css\">";

  $additional_header[] = "
<script type=\"text/javascript\">
var postnukeBaseURL = '$postnukeBaseURL';
var postnukeThemeURL = '$themeBaseURL';
var _editor_url = '$guppyBaseURL/HTMLArea-3.0-beta/'; // Use for htmlArea
var _editor_lang = \"en\";  // Use for htmlArea
var photoshareThumbnailSize = '$photoshareThumbnailSize';
</script>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"$guppyBaseURL/HTMLArea-3.0-beta/htmlarea.js\"></script>";
  $additional_header[] = "<script type=\"text/javascript\" src=\"$guppyBaseURL/HTMLArea-3.0-beta/dialog.js\"></script>";
  $additional_header[] = "<script type=\"text/javascript\" src=\"$guppyBaseURL/HTMLArea-3.0-beta/lang/en.js\"></script>";
  $additional_header[] = "<link rel=\"StyleSheet\" href=\"$guppyBaseURL/HTMLArea-3.0-beta/htmlarea.css\" type=\"text/css\">";

  $additional_header[] = "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"modules/pagesetter/guppy/jscalendar/css/calendar-win2k-cold-1.css\" title=\"win2k-cold-1\"/>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"modules/pagesetter/guppy/jscalendar/calendar.js\"></script>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"modules/pagesetter/guppy/jscalendar/lang/calendar-en.js\"></script>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"modules/pagesetter/guppy/jscalendar/calendar-setup.js\"></script>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"modules/photoshare/pnjavascript/findimage.js\"></script>";

  $additional_header[] = "<script type=\"text/javascript\" src=\"modules/pagesetter/pnjavascript/findpub.js\"></script>";

  $additional_header[] = "
<script type=\"text/javascript\">
HTMLArea.loadPlugin(\"TableOperations\");
</script>";
}


function guppy_redirect($url)
{
  pnRedirect($url);
}


/* Get/Set Guppy settings 
   - 'htmlAreaEnabled'  => true/false
   - 'htmlAreaStyled'   => Include theme stylesheet (true/false)
   - 'htmlAreaUndo'     => Undo enabled
   - 'htmlAreaWordKill' => Kill MS-Word codes on paste
 */

function guppy_getSetting($var)
{
  return pnModGetVar('guppy', $var);
}


function guppy_setSetting($var, $value)
{
  return pnModSetVar('guppy', $var, $value);
}


guppy_postnuke();

?>
