<?php
// $Id: pagesetter.php,v 1.2 2004/01/30 22:53:06 jornlind Exp $
// =======================================================================
// Pagesetter by Jorn Lind-Nielsen (C) 2003.
// ----------------------------------------------------------------------
// For POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WithOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// =======================================================================

require_once("modules/pagesetter/common.php");

$currentlang = pnUserGetLang();
include("modules/pagesetter/pnlang/$currentlang/userapi.php");


  // Inform PostNuke search framework of the functions this module uses
$search_modules[] = array( 'title'       => 'Pagesetter documents',
                           'func_search' => 'search_pagesetter',
                           'func_opt'    => 'search_pagesetter_opt'
                         );

  // Define a callback class suitable for PostNuke standard search
class PagesetterPNSearchCallback extends PagesetterSearchCallback
{
  var $count;
  var $html;

  function PagesetterPNSearchCallback()
  {
    $this->count = 0;
    $this->html = '';
  }


  function start()
  {
    $this->count = 0;
    $this->html = "Pagesetter:<ul>\n";
  }


  function found($tid, $pid, $pubTitle, $title, $url)
  {
    $this->html .= "<li>$pubTitle: <a href=\"$url\">$title</a></li>\n";
    ++$this->count;
  }


  function stop()
  {
    if ($this->count == 0)
      $this->html = _PGSEARCHNONEFOUND . '<br>';
    else
      $this->html .= "</ul>\n";
  }
};


  // "Print" search form in advanced search
function search_pagesetter_opt()
{
  global $bgcolor2;

  if (!pnSecAuthAction(0, 'pagesetter::', '::', ACCESS_READ))
    return;

  return   "<table border=\"0\" width=\"100%\"><tr bgcolor=\"$bgcolor2\"><td>"
         . "<input type=\"checkbox\" name=\"active_pagesetter\" id=\"active_pagesetter\" value=\"1\" checked>&nbsp;"
         . "<label for=\"active_pagesetter\">" . _PGSEARCH . "</label></td></tr></table>";
}


  // Do the searching (or rather - let the API do it)
function search_pagesetter()
{
  list($query,
       $bool,
       $startnum,
       $total,
       $active_pagesetter) = pnVarCleanFromInput('q',
                                                 'bool',
                                                 'startnum',
                                                 'total',
                                                 'active_pagesetter');

  if (empty($active_pagesetter))
    return;

  if (empty($query))
    return _PGSEARCHNONEFOUND . '<br>';

  if (!isset($startnum) || !is_numeric($startnum))
    $startnum = 1;

  if (isset($total) && !is_numeric($total))
    unset($total);

  if (!pnModAPILoad('pagesetter', 'user'))
    return pagesetterErrorPage(__FILE__, __LINE__, 'Failed to load Pagesetter user API');

  $callback = new PagesetterPNSearchCallback;
  $ok = pnModAPIFunc( 'pagesetter',
                      'user',
                      'search',
                      array('query'    => $query,
                            'match'    => $bool,
                            'callback' => &$callback) );

  if (!$ok)
    return pagesetterErrorAPIGet();

  return $callback->html;
}


?>
