<?php

// Thanks to Joerg Napp for some serious bugfixes in this plugin.

function smarty_function_pagesetter_listBrowser($args, &$smarty)
{
  //$smarty->caching = 0; // Nice for debugging ...

  if (!isset($args['field']))
    return "Missing 'field' argument in Smarty plugin 'pagesetter_listBrowser'";

  $field        = $args['field'];
  $listClass    = $args['listClass'];
  $level        = (empty($args['level']) ? 1000 : $args['level']);
  $topValue     = $args['topValue']; 
  $currentValue = (isset($args['currentValue']) ? $args['currentValue'] : pnVarCleanFromInput('cv'));

  $core = $smarty->get_template_vars('core');
  $tid = $core['tid'];

  if (!pnModAPILoad('pagesetter', 'admin'))
    return pagesetterErrorPage(__FILE__, __LINE__, 'Failed to load Pagesetter admin API');

  $listID = pnModAPIFunc( 'pagesetter',
                          'admin',
                          'getListIDByFieldName',
                          array('tid'   => $tid,
                                'field' => $field) );

  if ($listID === false)
    return pagesetterErrorAPIGet();

  $listInfo = pnModAPIFunc( 'pagesetter',
                            'admin',
                            'getList',
                             array('lid' => $listID,
                                   'topListValueID' => $topValue) );

  if ($listInfo === false)
    return pagesetterErrorAPIGet();

  // build the parameters for the URL.
  // these are the same for every item.
  $url_parameters = array();
  $url_parameters['tid'] = $tid;
  if (!empty($template)) {
    $url_parameters['tpl'] = $template;
  }

  $items  = $listInfo['items'];
  $indent = $items[0]['indent'];

  // the indentation of the first item
  $base_indent = $indent;
  
  $html = "<ul" . (isset($listClass) ? " class=\"$listClass\">" : "") . "\n";
  foreach ($items as $item) {
    
    // check if the current item is to be displayed
    // (i.e. if it is within the range of sublevels to show)
    if ($item['indent'] - $base_indent <= $level) {
        // open or close as many levels as necessary.
        $diff = $item['indent'] - $indent;
        $html .= str_repeat('<ul>',  ($diff < 0 ? 0 : $diff));
        $html .= str_repeat('</ul>', ($diff > 0 ? 0 : -$diff));

        // set parameter for the URL
        $url_parameters['filter'] = "$field:sub:$item[id]";
        $url_parameters['cv']     = $item['id'] ;

        $url = pnModUrl('pagesetter', 
                        'user', 
                        '',
                        $url_parameters);

        if ($currentValue == $item['id'])
          $className = " class=\"current\"";
        else
          $className = '';

        $html .= "<li$className><a href=\"$url\">$item[title]</a></li>\n";
        
        // keep the new indentation for the next round        
        $indent = $item['indent'];
    }
  }
  $html .= "</ul>\n";

  return $html;
}
?>
