<?php
function smarty_function_pagesetter_pubPagerplus($args, &$smarty)
{
    $core = &$smarty->get_template_vars('core');

    // Get stuff that exists in core
    $page      = isset($args['page']) ? intval($args['page']) : intval($core['page']);
    $baseURL   = isset($args['baseURL']) ? $args['baseURL'] : $core['baseURL'];

    // how many items do we have to show at all?
    if( !isset( $args['pubCount'] ) )
    {
        if( !pnModAPILoad('pagesetter', 'user' ) )
        {
            $smarty->trigger_error( "*** pubPagerplus: unable to load pagesetter userapi!!", E_ERROR );
            return false;
        }
        $list = pnModAPIFunc( 'pagesetter', 'user', 'getPubList', array( 'tid' => $core['tid'], 'noOfItems' => 999 ) );    
        $pubCount = count( $list['publications'] );
    }
    else
    {
        $pubCount = $args['pubCount'];
    }
    // lets see how many items we have to show per page
    if( !pnModAPILoad('pagesetter', 'admin' ) )
    {
        $smarty->trigger_error( "*** pubPagerplus: unable to load pagesetter adminapi!!", E_ERROR );
        return false;
    }
    $pinfo = pnModAPIFunc( 'pagesetter', 'admin', 'getPubTypeInfo', array( 'tid' => $core['tid'], 'noOfItems' => 999 ) );    
    $perpage = $pinfo['publication']['listCount'];

    // Get stuff for presentation
    $prev          = isset($args['prev']) ? $args['prev'] : "<";
    $first         = isset($args['first']) ? $args['first'] : "<<";
    $next          = isset($args['next']) ? $args['next'] : ">";
    $last          = isset($args['last']) ? $args['last'] : ">>";
    $separator     = isset($args['separator']) ? $args['separator'] : "&nbsp;";

    $html = "";
    // how many pages will there be
    $pages = ceil($pubCount / $perpage);
    if( $pubCount > $perpage )
    {
        if ($page > 0)
        {
            $html .= "<a href='$baseURL&page=1'>$first</a>$separator";
            $html .= "<a href='$baseURL&page=$page'>$prev</a>$separator";
        }
        
        for( $n=1;$n<=$pages;$n++ )
        {
            $html .="$separator<a href='$baseURL&page=$n'>$n</a>";
        }

        if( $page < $pages-1 )
        {
            $npage = $page+2;
            $npages = $pages+1;
            $html .= "$separator<a href='$baseURL&page=$npage'>$next</a>";
            $html .= "$separator<a href='$baseURL&page=$pages'>$last</a>";
        }
    }
    
    return $html;
}

?>